#include <iostream>
#include <string>
#include <string.h>
#include <fstream>


struct circus
{
string name;
string address;
int employees;

circus()
{ }
circus(string a, string b, int c)
{name=a; address=b; employees=c;}
};


struct animal
{
string name;
string species;
string birthday;
double price;
string circus;

animal()
{}
animal(string a, string b, string c, double d, string e)
{name=a; species=b; birthday=c; price=d; circus=e;}
};


struct Link
{
circus * cdata; //1
animal * adata; //2
Link * extradat; // for linking animals to circus data and circus to animal list
Link * next;

Link()
{}
Link (circus *a, animal* b, Link *C)
	{
	cdata=a;
	adata=b;
	next=C;
	}
};


Link * circus_from_file(string filename) //Creates linked list for circus data
{
Link * head=NULL;
Link * temp=NULL;
ifstream fin;
fin.open("circuses.txt");
if (fin.fail())
	cerr<<"file not found\n";
if (fin.is_open())
{
	while(true)
		{
		string a,b;
		int c;
		fin>>a>>b>>c;
		//cout << a <<":"<<b<<":"<<c<<"\n";
		if (fin.fail())break;
		circus * e = new circus(a, b, c);
		temp = new Link(e,NULL,head);
		head=temp;
		}
}
else
	cout<<"Can't open file";
fin.close();
return head;
}


Link * animal_from_file(string filename) //Creates linked list for Animal
{
Link * temp= NULL;
Link * head=NULL;
ifstream fin("animals.txt");
if(fin.fail())
	cerr<<"file not found\n";
while(true)
	{
	string a,b,c;
	double d;
	string e;
	fin>>a>>b>>c>>d>>e;
	if (fin.fail())break;
	animal * f = new animal(a,b,c,d,e);
	temp=new Link(NULL,f,head);
	head=temp;
	}
return head;
}

void printcircus (Link * first) //prints data of entire linked list of circuses.
{
Link * temp = first;

while (temp !=NULL)
	{
	cout << "Name:"<< temp->cdata->name << "   Business Address: "<<
		temp->cdata->address << "   Number of Employees: " <<
		temp->cdata->employees<<"\n"; 
		temp = temp->next ;
	}
}



void printanimal (Link * first) //prints data of entire linked list of animals
{
Link * temp = first;
while (temp !=NULL)
	{
	cout << "Name: " << temp->adata->name <<
		"   Species: " << temp->adata->species <<
		"   Birthday: " << temp->adata->birthday <<
		"   Price:  $" << temp->adata->price <<
		"   Circus: " << temp->adata->circus<<"\n";
	temp = temp->next;
	}
cout<<"\n";
}


Link * finda(Link * first, string search) //searches for animal input by user
{
Link * temp = first;

while (temp != NULL)
	{
	if (temp->adata->name == search)
		{
		return temp;
		}
	else if(temp->adata->species==search)
		{
		return temp;
		}
	temp = temp->next;
	}
return NULL;
}


Link * findc(Link * first, string search) //searches for circus input by user
{
Link * temp = first;
while (temp !=NULL)
	{
	if(temp->cdata->name == search)
		{
		return temp;
		}
	temp = temp->next;
	}
return NULL;
}


void addc(Link * animals, Link * circuses) //adds link of circus animal belongs to to animal link
{
Link * temp = animals;
while( temp !=NULL)
	{
	Link * circdat;
	circdat = new Link();
	circdat = findc (circuses, temp->adata->circus);
	temp->extradat=circdat;
	temp=temp->next;
	}
}

void adda(Link * animals, Link * circuses) //adds linked list of animals belonging to a circus to circus's link
{
Link * ctemp = circuses;
Link * atemp = animals;

while(ctemp !=NULL)
	{
	Link * head=NULL;
	Link * xtemp=NULL;
	atemp=animals;
	//cout<<ctemp->cdata->name<<":";
	while (atemp !=NULL)
		{
		if (atemp->adata->circus==ctemp->cdata->name)
			{
			xtemp=new Link(NULL, atemp->adata, head);
			//cout<<xtemp->adata->name;							
			head=xtemp;	
			}
		atemp=atemp->next;
		}
	ctemp->extradat=xtemp;
	ctemp=ctemp->next;
	}
}




void print_onea(Link * print1)//prints a search result for an animal, and its circus info
{
if (print1 == NULL)
	cout << "No animals match search\n\n";
else
	{
	cout << "SEARCH RESULTS FOR ANIMAL: \n" << "Name: " << print1->adata->name <<
		"\n Species: " << print1->adata->species <<
		"\n Birthday: " << print1->adata->birthday <<
		"\n Price: $ " << print1->adata->price <<"\n\n";

	cout << "CIRCUS INFORMATION FOR ANIMAL: \n " << "Name:"<< print1->extradat->cdata->name <<
		"\n Business Address: " << print1->extradat->cdata->address << 
		"\n Number of Employees: " << print1->extradat->cdata->employees<< "\n\n";
	}
}


void print_onec(Link *  print2)//prints a search result for a circus, and the info of all its animals.
{
if (print2 == NULL)
	cout << "No circuses match search \n\n";
else
	{
	cout << "SEARCH RESULTS FOR CIRCUS: \n" << "Name: " << print2->cdata->name <<
		" Business Address: " << print2->cdata->address <<
		" Number of Employees: " << print2->cdata->employees <<"\n\n";
	cout << "ALL ANIMALS AT CIRCUS: \n";
	printanimal (print2->extradat);
	cout<<"\n\n";
	}
}

void print_friends(Link * animal, Link * circus, string search)//finds and prints all members or an animal's circus
{
Link*first=finda(animal, search);
if(first!=NULL)
{
	Link*temp=findc(circus,first->adata->circus);
	temp=temp->extradat; 

	cout<<"FRIENDS OF ANIMAL: \n";
	while(temp!=NULL)
		{
		if(first->adata->name!=temp->adata->name)
			{
			cout<<"Name: "<<temp->adata->name <<
				"   Species: "<<temp->adata->species<<"\n";
			}
		temp=temp->next;
		}
	cout<<"\n";
	}
else
	cout << "No Animals Match Search.\n\n";
}


	
void main ()
{
Link * rootc = circus_from_file("circuses.txt");
//cout << length(root) << "entries.\n";
cout << "ALL CIRCUSES: \n";
printcircus(rootc);

Link * roota = animal_from_file("animals.txt");
//cout << length(root) << "entries.\n";
cout<< "ALL ANIMALS: \n";
printanimal(roota);

addc(roota, rootc);
adda(roota, rootc);


string s;
string r;
 
while(true)
	{
	cout<<"Type 'X' to search for circus.  Type 'Y' to search for animal.  Type 'Z' to find the friends of an animal.  Type 'End' to stop at any time. \n";
	cin>>s;
	cout<<"\n";
	if (s=="X"||s=="x")
		{
		cout<< "Search for a Circus: ";
		cin>>r;
		cout<<"\n";
		Link*u;
		u=findc(rootc,r);
		print_onec(u);
		}
	else if (s=="Y"||s=="y")
		{
		cout<<"Search for an Animal: ";
		cin>>r;
		cout<<"\n";
		Link*t;
		t=finda(roota,r);
		print_onea(t);
		}
	else if (s=="Z"||s=="z")
		{
		cout<<"Type in name of Animal: ";
		cin>>r;
		cout<<"\n";
		print_friends(roota, rootc, r);
		}
	else if(s=="end" || s=="End" || s=="END")
		break;

	}

cout<< "cool story bro.";
}
